#include <iostream>
#include <vector>
#include <map>

using namespace std;

typedef long long int ll;

int main() {
    ios::sync_with_stdio(false);

    ll p_number;
    cin >> p_number;

    vector<bool> primes(p_number + 1, true);
    primes[1] = false;
    primes[0] = false;
    for (ll p = 2; p <= p_number; ++p) {
        for (ll i = 2; i < p; ++i) {
            if (p % i == 0) {
                primes[p] = false;
            }
        }
    }

    map<ll, ll> dp;
    dp[2] = 1;
    dp[3] = 1;

    for (int p = 0; p <= p_number; ++p) {
        if (!primes[p]) {
            continue;
        }
        ll cur_sum = 0;
        for (ll cur_p = max(0, p - 14); cur_p < p; ++cur_p) {
            if (primes[cur_p]) {
                cur_sum += dp[cur_p];
            }
        }
        if (cur_sum != 0) {
            dp[p] = cur_sum;
        }
    }

    cout << dp[p_number] << endl;

}